﻿Imports System.Windows.Forms

Public Class ComSettings

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        If TypeName(ComboBoxComPorts.SelectedItem) = "String" Then
            If ComboBoxComPorts.SelectedItem.ToString.Length > 2 Then
                If Not TypeName(MutterUhrControlMain.oCOMPort) = "Nothing" Then
                    If MutterUhrControlMain.oCOMPort.IsOpen Then
                        MutterUhrControlMain.oCOMPort.Close()
                    End If
                End If
                MutterUhrControlMain.sCOMPort = ComboBoxComPorts.SelectedItem.ToString()
                MutterUhrControlMain.oRegApplication.SetValue(MutterUhrControlMain.REGISTRY_KEY_COMPORT, ComboBoxComPorts.SelectedItem)
                MutterUhrControlMain.fOpenCOM(MutterUhrControlMain.sCOMPort, MutterUhrControlMain.SERIAL_BAUD_RATE, MutterUhrControlMain.SERIAL_DATA_BITS, MutterUhrControlMain.SERIAL_PARITY, MutterUhrControlMain.SERIAL_STOP_BITS, MutterUhrControlMain.SERIAL_HANDSHAKE, MutterUhrControlMain.oCOMPort)
            End If
        End If
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub



    Private Sub ComSettings_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim sPort As String
        ComboBoxComPorts.Items.Clear()
        If System.IO.Ports.SerialPort.GetPortNames.Length = 0 Then
            MsgBox("No COM Ports found! Exit Applications", MsgBoxStyle.Critical, "ERR0R")
            Application.Exit()
        End If
        For Each sPort In System.IO.Ports.SerialPort.GetPortNames
            ComboBoxComPorts.Items.Add(sPort)
        Next
        If Not IsNothing(MutterUhrControlMain.sCOMPort) Then
            If MutterUhrControlMain.sCOMPort.Length > 2 Then
                ComboBoxComPorts.SelectedItem = MutterUhrControlMain.sCOMPort
            End If
        Else
            ComboBoxComPorts.SelectedItem = ComboBoxComPorts.Items(0).ToString()
        End If
    End Sub

    Private Sub ComboBoxComPorts_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxComPorts.SelectedIndexChanged
        If Not IsNothing(MutterUhrControlMain.oCOMPort) Then
            If MutterUhrControlMain.oCOMPort.IsOpen Then
                MutterUhrControlMain.oCOMPort.Close()
            End If
        End If
        MutterUhrControlMain.fOpenCOM(ComboBoxComPorts.Items(0).ToString(), MutterUhrControlMain.SERIAL_BAUD_RATE, MutterUhrControlMain.SERIAL_DATA_BITS, MutterUhrControlMain.SERIAL_PARITY, MutterUhrControlMain.SERIAL_STOP_BITS, MutterUhrControlMain.SERIAL_HANDSHAKE, MutterUhrControlMain.oCOMPort)
    End Sub

    Private Sub Cancel_Button_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub
End Class
