﻿Module header
    Public Class TranslatedString
        Private sLanguage As String
        Public Property Language() As String
            Get
                Return (Me.sLanguage)
            End Get
            Set(ByVal value As String)
                sLanguage = value
            End Set
        End Property
        Sub New(ByVal sDefaultLanguage As String)
            sLanguage = sDefaultLanguage
        End Sub
        '###################### Strings ##################################
        Public ReadOnly Property Connect() As String
            Get
                If sLanguage = "DE" Then
                    Return "Verbinden"
                Else
                    Return "Connect"
                End If
            End Get
        End Property
        Public ReadOnly Property Disconnect() As String
            Get
                If sLanguage = "DE" Then
                    Return "Verbindung trennen"
                Else
                    Return "Disconnect"
                End If
            End Get
        End Property
        Public ReadOnly Property IsDisconnected() As String
            Get
                If sLanguage = "DE" Then
                    Return "Nicht verbunden"
                Else
                    Return "Not connected"
                End If
            End Get
        End Property
        Public ReadOnly Property DCF77Currently() As String
            Get
                If sLanguage = "DE" Then
                    Return "DCF77 synchronisation ist momentan:"
                Else
                    Return "DCF77 sync is currently:"
                End If
            End Get
        End Property
        Public ReadOnly Property DCF77Enable2Disable() As String
            Get
                If sLanguage = "DE" Then
                    Return " aktiviert. Deaktivieren?"
                Else
                    Return " enabled. Disable clock control with DCF77?"
                End If
            End Get
        End Property
        Public ReadOnly Property DCF77Disable2Enable() As String
            Get
                If sLanguage = "DE" Then
                    Return " deaktiviert. Aktivieren?"
                Else
                    Return " disabled. Enable clock control with DCF77?"
                End If
            End Get
        End Property
        Public ReadOnly Property DCF77SuccessEnabled() As String
            Get
                If sLanguage = "DE" Then
                    Return "DCF77 Synchronisierung erfolgreich aktiviert"
                Else
                    Return "Clock controlling with DCF77 successfully enabled"
                End If
            End Get
        End Property
        Public ReadOnly Property DCF77SuccessDisabled() As String
            Get
                If sLanguage = "DE" Then
                    Return "DCF77 Synchronisierung erfolgreich deaktiviert"
                Else
                    Return "Clock controlling with DCF77 successfully disabled"
                End If
            End Get
        End Property
        Public ReadOnly Property DCF77ErrorEnabling() As String
            Get
                If sLanguage = "DE" Then
                    Return "Fehler beim aktivieren der DCF77 Synchronisierung aufgetreten"
                Else
                    Return "Cannot enable DCF77 Mode!"
                End If
            End Get
        End Property
        Public ReadOnly Property DCF77ErrorDisabling() As String
            Get
                If sLanguage = "DE" Then
                    Return "Fehler beim deaktivieren der DCF77 Synchronisierung aufgetreten"
                Else
                    Return "Cannot disable DCF77 Mode!"
                End If
            End Get
        End Property
        Public ReadOnly Property DCF77EnableClock() As String
            Get
                If sLanguage = "DE" Then
                    Return "DCF77 Sychronisation aktivieren"
                Else
                    Return "Enable Clock control with DCF77"
                End If
            End Get
        End Property
        Public ReadOnly Property DCF77DisableClock() As String
            Get
                If sLanguage = "DE" Then
                    Return "DCF77 Sychronisation deaktivieren"
                Else
                    Return "Disable Clock control with DCF77"
                End If
            End Get
        End Property
        Public ReadOnly Property COMPortNotSelected() As String
            Get
                If sLanguage = "DE" Then
                    Return "Noch nicht gewählt"
                Else
                    Return "Not selected yet"
                End If
            End Get
        End Property
        Public ReadOnly Property Open() As String
            Get
                If sLanguage = "DE" Then
                    Return "Verbunden"
                Else
                    Return "Open"
                End If
            End Get
        End Property
        Public ReadOnly Property Closed() As String
            Get
                If sLanguage = "DE" Then
                    Return "Getrennt"
                Else
                    Return "Closed"
                End If
            End Get
        End Property
        Public ReadOnly Property Enabled() As String
            Get
                If sLanguage = "DE" Then
                    Return "Aktiv"
                Else
                    Return "Enabled"
                End If
            End Get
        End Property
        Public ReadOnly Property Disabled() As String
            Get
                If sLanguage = "DE" Then
                    Return "Deaktiviert"
                Else
                    Return "Disabled"
                End If
            End Get
        End Property
        Public ReadOnly Property Halted() As String
            Get
                If sLanguage = "DE" Then
                    Return "gestoppt"
                Else
                    Return "Halted"
                End If
            End Get
        End Property
        Public ReadOnly Property Running() As String
            Get
                If sLanguage = "DE" Then
                    Return "in Betrieb"
                Else
                    Return "running"
                End If
            End Get
        End Property
        Public ReadOnly Property SyncActiveForward() As String
            Get
                If sLanguage = "DE" Then
                    Return "Synchronisation aktiv (Vorwärts)"
                Else
                    Return "Syncing active (forward)"
                End If
            End Get
        End Property
        Public ReadOnly Property SyncActiveWaiting() As String
            Get
                If sLanguage = "DE" Then
                    Return "Synchronisation aktiv (Wartenend)"
                Else
                    Return "Syncing active (waiting)"
                End If
            End Get
        End Property
        Public ReadOnly Property HaltSlaveClocks() As String
            Get
                If sLanguage = "DE" Then
                    Return "Nebenuhren anhalten"
                Else
                    Return "Halt slave clock(s)"
                End If
            End Get
        End Property
        Public ReadOnly Property ContinueSlaveClocks() As String
            Get
                If sLanguage = "DE" Then
                    Return "Nebenuhren starten"
                Else
                    Return "Continue slave clock(s)"
                End If
            End Get
        End Property
        Public ReadOnly Property StateConnecting() As String
            Get
                If sLanguage = "DE" Then
                    Return "Status: Verbinde..."
                Else
                    Return "State: connecting... "
                End If
            End Get
        End Property
        Public ReadOnly Property StateTimeout() As String
            Get
                If sLanguage = "DE" Then
                    Return "Status: Zeitüberschreitung"
                Else
                    Return "State: Timeout "
                End If
            End Get
        End Property
        Public ReadOnly Property StateConnected() As String
            Get
                If sLanguage = "DE" Then
                    Return "Status: Verbunden"
                Else
                    Return "State: Connected "
                End If
            End Get
        End Property
        Public ReadOnly Property StateProtokollError() As String
            Get
                If sLanguage = "DE" Then
                    Return "Status: Protokollfehler "
                Else
                    Return "State: Protocol error "
                End If
            End Get
        End Property
        Public ReadOnly Property StateUnknownCommand() As String
            Get
                If sLanguage = "DE" Then
                    Return "Status: Unbekanntes Kommando "
                Else
                    Return "State: Command unknown "
                End If
            End Get
        End Property
        Public ReadOnly Property Firmwareversion() As String
            Get
                If sLanguage = "DE" Then
                    Return "Firmwareversion: "
                Else
                    Return "Firmwareversion: "
                End If
            End Get
        End Property
        Public ReadOnly Property NoPowerfaultDetected() As String
            Get
                If sLanguage = "DE" Then
                    Return "Es wurde noch kein Spannungsausfall erfasst"
                Else
                    Return "No powerfault detected yet"
                End If
            End Get
        End Property
        Public ReadOnly Property ProgramName() As String
            Get
                If sLanguage = "DE" Then
                    Return "Steuerprogramm für Mutteruhr"
                Else
                    Return "Masterclock Controlprogram"
                End If
            End Get
        End Property
        Public ReadOnly Property SuccessMaster2Slave() As String
            Get
                If sLanguage = "DE" Then
                    Return "Mutteruhr erfolgreich auf Zeit der Nebenuhr(en) gesetzt"
                Else
                    Return "Successfully set masterclock to slaveclock(s)"
                End If
            End Get
        End Property
        Public ReadOnly Property ErrorMaster2Slave() As String
            Get
                If sLanguage = "DE" Then
                    Return "Fehler beim setzen der Mutteruhr auf die Zeit der Nebenuhr(en). Fehler: "
                Else
                    Return "Failed set masterclock to slaveclock(s). Errorcode: "
                End If
            End Get
        End Property
        Public ReadOnly Property ErrorMaster2SlaveTimeout() As String
            Get
                If sLanguage = "DE" Then
                    Return "Fehler beim setzen der Mutteruhr auf die Zeit der Nebenuhr(en). Zeitüberschreitung"
                Else
                    Return "Failed set masterclock to slaveclock(s): Serialtimeout"
                End If
            End Get
        End Property
        Public ReadOnly Property SuccessFullySet() As String
            Get
                If sLanguage = "DE" Then
                    Return "Erfolgreich gesetzt"
                Else
                    Return "Successfully set"
                End If
            End Get
        End Property
        Public ReadOnly Property SetFailed() As String
            Get
                If sLanguage = "DE" Then
                    Return "Fehler beim setzen. Fehlercode: "
                Else
                    Return "Set failed: "
                End If
            End Get
        End Property
        Public ReadOnly Property SetFailedTimeout() As String
            Get
                If sLanguage = "DE" Then
                    Return "Fehler beim setzen. Zeitüberschreitung"
                Else
                    Return "Set failed: Serialtimeout"
                End If
            End Get
        End Property
        Public ReadOnly Property ErrorMessage() As String
            Get
                If sLanguage = "DE" Then
                    Return "Fehler"
                Else
                    Return "Error"
                End If
            End Get
        End Property
        Public ReadOnly Property About() As String
            Get
                If sLanguage = "DE" Then
                    Return "Mutteruhr Verwaltungsprogramm" & vbCrLf & vbCrLf & "Michael Albert" & vbCrLf & vbCrLf & "Version: "
                Else
                    Return "Masterclock control program" & System.Deployment.Application.ApplicationDeployment.CurrentDeployment.CurrentVersion.ToString() & vbCrLf & vbCrLf & "Michael Albert" & vbCrLf & vbCrLf & "Version: "
                End If
            End Get
        End Property
        Public ReadOnly Property Info() As String
            Get
                If sLanguage = "DE" Then
                    Return "Info"
                Else
                    Return "Info"
                End If
            End Get
        End Property
        Public ReadOnly Property SlaveClockCurrently() As String
            Get
                If sLanguage = "DE" Then
                    Return "Nebenuhren:"
                Else
                    Return "Slave clocks are currently:"
                End If
            End Get
        End Property
        Public ReadOnly Property SlaveClocksHaltedContinueQuestion() As String
            Get
                If sLanguage = "DE" Then
                    Return " angehalten. Starten?"
                Else
                    Return " Halted. Continue clock(s)?"
                End If
            End Get
        End Property
        Public ReadOnly Property SlaveClocksRunningHaltQuestion() As String
            Get
                If sLanguage = "DE" Then
                    Return " gestartet. Anhalten?"
                Else
                    Return " Running. Halt clock(s)?"
                End If
            End Get
        End Property
        Public ReadOnly Property SetHaltFailed() As String
            Get
                If sLanguage = "DE" Then
                    Return "Anhalten fehlgeschlagen, Fehler: "
                Else
                    Return "Set halt failed: "
                End If
            End Get
        End Property
        Public ReadOnly Property SetContinueFailed() As String
            Get
                If sLanguage = "DE" Then
                    Return "Starten fehlgeschlagen, Fehler: "
                Else
                    Return "Set continue failed: "
                End If
            End Get
        End Property
        Public ReadOnly Property Command() As String
            Get
                If sLanguage = "DE" Then
                    Return "Befehl"
                Else
                    Return "Command"
                End If
            End Get
        End Property
        Public ReadOnly Property M24h() As String
            Get
                If sLanguage = "DE" Then
                    Return "24 Stunden"
                Else
                    Return "24 Hours"
                End If
            End Get
        End Property
        Public ReadOnly Property M12h() As String
            Get
                If sLanguage = "DE" Then
                    Return "12 Stunden"
                Else
                    Return "12 Hours"
                End If
            End Get
        End Property
        Public ReadOnly Property SetSyncMode24Successfully() As String
            Get
                If sLanguage = "DE" Then
                    Return "24 Stunden Synchronisationsmodus erfolgreich aktiviert"
                Else
                    Return "Set 24h syncronisationmode successfully."
                End If
            End Get
        End Property
        Public ReadOnly Property SetSyncMode24Failed() As String
            Get
                If sLanguage = "DE" Then
                    Return "Fehler beim aktivieren des 24 Stunden Synchronisationsmodus"
                Else
                    Return "Set 24h syncorisationmode failed."
                End If
            End Get
        End Property
        Public ReadOnly Property SetSyncMode12Successfully() As String
            Get
                If sLanguage = "DE" Then
                    Return "12 Stunden Synchronistaionsmodus erfolgreich aktiviert"
                Else
                    Return "Set 12h syncronisationmode successfully."
                End If
            End Get
        End Property
        Public ReadOnly Property SetSyncMode12Failed() As String
            Get
                If sLanguage = "DE" Then
                    Return "12 Stunden Synchronisationsmodus erfolgreich aktiviert"
                Else
                    Return "Set 12h syncronisationmode failed"
                End If
            End Get
        End Property
        Public ReadOnly Property SetPulseWidthFailed() As String
            Get
                If sLanguage = "DE" Then
                    Return "Fehler beim setzen der Ausgangspulsweite"
                Else
                    Return "SSet pulsewidth failed"
                End If
            End Get
        End Property
        Public ReadOnly Property SetPulseWidthSuccessfully() As String
            Get
                If sLanguage = "DE" Then
                    Return "Ausgangspulsweite erfolgreich gesetzt"
                Else
                    Return "Set pulsewidth successfully"
                End If
            End Get
        End Property
        Public ReadOnly Property DCF77SyncDisableQuestion() As String
            Get
                If sLanguage = "DE" Then
                    Return "DCF77 Synchronisation deaktivieren?"
                Else
                    Return "Disable clock controlling with DCF77 ?"
                End If
            End Get
        End Property
        Public ReadOnly Property DCF77SyncEnableQuestion() As String
            Get
                If sLanguage = "DE" Then
                    Return "DCF77 Synchronisation aktivieren?"
                Else
                    Return "Enable clock controlling with DCF77 ?"
                End If
            End Get
        End Property
        Public ReadOnly Property DCF77_PARITY_ERROR_MINUTE() As String
            Get
                If sLanguage = "DE" Then
                    Return "Paritäts Fehler Minute"
                Else
                    Return "Parity error minute"
                End If
            End Get
        End Property
        Public ReadOnly Property DCF77_PARITY_ERROR_HOUR() As String
            Get
                If sLanguage = "DE" Then
                    Return "Paritäts Fehler Stunde"
                Else
                    Return "Parity error hour"
                End If
            End Get
        End Property
        Public ReadOnly Property DCF77_CYCLE_ERROR() As String
            Get
                If sLanguage = "DE" Then
                    Return "Empfangene Signal Periode außerhalb des gültigen Bereichs"
                Else
                    Return "Receive cycle out of range."
                End If
            End Get
        End Property
        Public ReadOnly Property DCF77_NO_STATUS() As String
            Get
                If sLanguage = "DE" Then
                    Return "Kein Status verfügbar"
                Else
                    Return "No status available."
                End If
            End Get
        End Property
        Public ReadOnly Property DCF77_PULSE_RANGE_ERROR() As String
            Get
                If sLanguage = "DE" Then
                    Return "Empfangener Signal Puls außerhalb des gültigen Bereichs"
                Else
                    Return "Received pulse out of range"
                End If
            End Get
        End Property
        Public ReadOnly Property DCF77_PARITY_ERROR_DATE() As String
            Get
                If sLanguage = "DE" Then
                    Return "Paritäts Fehler Datum"
                Else
                    Return "Parity error date"
                End If
            End Get
        End Property

        Public ReadOnly Property NoDCF77DataReceived() As String
            Get
                If sLanguage = "DE" Then
                    Return "Noch keine DCF77 Daten empfangen"
                Else
                    Return "No dcf77 data received yet"
                End If
            End Get
        End Property
        Public ReadOnly Property UNKNOWN_STATE() As String
            Get
                If sLanguage = "DE" Then
                    Return "Unbekannter Status"
                Else
                    Return "Unknown state"
                End If
            End Get
        End Property
        Public ReadOnly Property cancel() As String
            Get
                If sLanguage = "DE" Then
                    Return "Abbrechen"
                Else
                    Return "Cancel"
                End If
            End Get
        End Property
        Public ReadOnly Property ok() As String
            Get
                If sLanguage = "DE" Then
                    Return "Ok"
                Else
                    Return "ok"
                End If
            End Get
        End Property
        Public ReadOnly Property DCF77_WAIT_FOR_SYNCING() As String
            Get
                If sLanguage = "DE" Then
                    Return "Warte auf Daten"
                Else
                    Return "waiting for data"
                End If
            End Get
        End Property
        Public ReadOnly Property DCF77_SYNCING() As String
            Get
                If sLanguage = "DE" Then
                    Return "Empfange Daten"
                Else
                    Return "receiving data"
                End If
            End Get
        End Property
        Public ReadOnly Property DCF77_INIT() As String
            Get
                If sLanguage = "DE" Then
                    Return "Initialisierung läuft"
                Else
                    Return "initstate"
                End If
            End Get
        End Property
        Public ReadOnly Property Sunday() As String
            Get
                If sLanguage = "DE" Then
                    Return "Sonntag"
                Else
                    Return "Sunday"
                End If
            End Get
        End Property
        Public ReadOnly Property Monday() As String
            Get
                If sLanguage = "DE" Then
                    Return "Montag"
                Else
                    Return "Monday"
                End If
            End Get
        End Property
        Public ReadOnly Property Tuesday() As String
            Get
                If sLanguage = "DE" Then
                    Return "Dienstag"
                Else
                    Return "Tuesday"
                End If
            End Get
        End Property
        Public ReadOnly Property Wednesday() As String
            Get
                If sLanguage = "DE" Then
                    Return "Mittwoch"
                Else
                    Return "Wednesday"
                End If
            End Get
        End Property
        Public ReadOnly Property Thursday() As String
            Get
                If sLanguage = "DE" Then
                    Return "Donnerstag"
                Else
                    Return "Thursday"
                End If
            End Get
        End Property
        Public ReadOnly Property Friday() As String
            Get
                If sLanguage = "DE" Then
                    Return "Freitag"
                Else
                    Return "Friday"
                End If
            End Get
        End Property
        Public ReadOnly Property Saturday() As String
            Get
                If sLanguage = "DE" Then
                    Return "Samstag"
                Else
                    Return "Saturday"
                End If
            End Get
        End Property
        '##################################################################
    End Class

    Public Class PowerFaultDateTime
        'uint8_t ee_iPowerFaultHour EEMEM = 0;
        'uint8_t ee_iPowerFaultMinute EEMEM = 0xFF;
        'uint8_t ee_iPowerFaultDay EEMEM = 0xFF;
        'int8_t ee_iPowerFaultMonth EEMEM = 0;
        'uint8_t ee_iPowerFaultYear EEMEM = 0;
        'uint8_t ee_iPowerFaultWeekday EEMEM = 0;
        'int8_t ee_bMEZ EEMEM = TRUE;
        Private iYear As Integer = 0, iMonth As Integer = 0, iDay As Integer = 0, iWeekday As DayOfWeek = 0
        Private iHour As Integer = 0, iMinute As Integer = 0, iSecond As Integer = 0
        Private aInDataArray(7) As String
        Private oPowerfaultDateTime As DateTime
        Private sPowerfaultDateTimetext As String
        Private oTranslatedStrings As TranslatedString
        Public ReadOnly Property datetime() As DateTime
            Get
                Return (oPowerfaultDateTime)
            End Get
        End Property
        Public ReadOnly Property datetimestring() As String
            Get
                Return (sPowerfaultDateTimetext)
            End Get
        End Property
        Public Property weekday() As DayOfWeek
            Get
                Return (iWeekday)
            End Get
            Set(ByVal value As DayOfWeek)
                iWeekday = value
            End Set
        End Property
        Public Property year() As Integer
            Get
                Return (iYear)
            End Get
            Set(ByVal value As Integer)
                iYear = value
            End Set
        End Property
        Public Property month() As Integer
            Get
                Return (iMonth)
            End Get
            Set(ByVal value As Integer)
                iMonth = value
            End Set
        End Property
        Public Property day() As Integer
            Get
                Return (iDay)
            End Get
            Set(ByVal value As Integer)
                iDay = value
            End Set
        End Property
        Public Property hour() As Integer
            Get
                Return (iHour)
            End Get
            Set(ByVal value As Integer)
                iHour = value
            End Set
        End Property
        Public Property minute() As Integer
            Get
                Return (iMinute)
            End Get
            Set(ByVal value As Integer)
                iMinute = value
            End Set
        End Property
        Public Property second() As Integer
            Get
                Return (iSecond)
            End Get
            Set(ByVal value As Integer)
                iSecond = value
            End Set
        End Property
        Private Function fGetIntAS2DigitString(ByVal iIn As Integer) As String
            If iIn <= 9 And iIn >= 0 Then
                Return ("0" & iIn.ToString)
            Else
                Return (iIn.ToString)
            End If
        End Function
        Private Function fGetWeekdayString(ByVal iWeekday As Integer)
            Select Case iWeekday
                Case System.DayOfWeek.Sunday
                    Return (oTranslatedStrings.Sunday)
                Case System.DayOfWeek.Monday
                    Return (oTranslatedStrings.Monday)
                Case System.DayOfWeek.Tuesday
                    Return (oTranslatedStrings.Tuesday)
                Case System.DayOfWeek.Wednesday
                    Return (oTranslatedStrings.Wednesday)
                Case System.DayOfWeek.Thursday
                    Return (oTranslatedStrings.Thursday)
                Case System.DayOfWeek.Friday
                    Return (oTranslatedStrings.Friday)
                Case System.DayOfWeek.Saturday
                    Return (oTranslatedStrings.Saturday)
                Case Else
                    Return ("---")
            End Select
        End Function
        Sub New(ByRef oTransString As TranslatedString)
            oTranslatedStrings = oTransString
        End Sub
        Public Property inall() As String()
            Get
                Return (aInDataArray)
            End Get
            Set(ByVal value As String())
                aInDataArray = value
                iYear = Convert.ToInt32(aInDataArray.GetValue(0))
                iMonth = Convert.ToInt32(aInDataArray.GetValue(1))
                iDay = Convert.ToInt32(aInDataArray.GetValue(2))
                iWeekday = Convert.ToInt32(aInDataArray.GetValue(3))
                iHour = Convert.ToInt32(aInDataArray.GetValue(4))
                iMinute = Convert.ToInt32(aInDataArray.GetValue(5))
                If Not iMinute = &HFF Then
                    iSecond = Convert.ToInt32(aInDataArray.GetValue(6))
                    If iDay = &HFF Then
                        oPowerfaultDateTime = New DateTime(1970, 1, 1, iHour, iMinute, iSecond)
                        sPowerfaultDateTimetext = iHour & ":" & iMinute & ":" & iSecond & " "
                    Else
                        oPowerfaultDateTime = New DateTime(iYear, iMonth, iDay, iHour, iMinute, iSecond)
                        'sPowerfaultDateTimetext = iWeekday.ToString() & "  " & fGetIntAS2DigitString(iDay) & "." & fGetIntAS2DigitString(iMonth) & "." & "20" & iYear.ToString & " " _
                        ' & fGetIntAS2DigitString(iHour) & ":" & fGetIntAS2DigitString(iMinute) & ":" & fGetIntAS2DigitString(iSecond) & " "
                        sPowerfaultDateTimetext = fGetWeekdayString(iWeekday) & "  " & fGetIntAS2DigitString(iDay) & "." & fGetIntAS2DigitString(iMonth) & "." & "20" & iYear.ToString & " " _
                         & fGetIntAS2DigitString(iHour) & ":" & fGetIntAS2DigitString(iMinute) & ":" & fGetIntAS2DigitString(iSecond) & " "

                    End If
                Else
                    sPowerfaultDateTimetext = oTranslatedStrings.NoPowerfaultDetected
                End If
            End Set
        End Property
    End Class
    Public Class DCF77DateTime
        Private iYear As Integer = 0, iMonth As Integer = 0, iDay As Integer = 0, iWeekday As DayOfWeek = 0
        Private iHour As Integer = 0, iMinute As Integer = 0, iSecond As Integer = 0
        Private iValid4Seconds As Integer = 0, iLastStatus As Integer = 0, iCurrentStatus As Integer = 0
        Private iLastReceivedInSeconds As UInt32
        Private bMEZ As Boolean = False
        Private aInDataArray(11) As String
        Private oDCF77DateTime As DateTime
        Private sDCF77Date As String = ""
        Private sLastResultText As String
        Private sCurrentStateText As String
        Private oTranslatedStrings As TranslatedString

        Enum eDCFLastResult
            DCF77_RECEIVE_COMPLETE_SUCCESSFULLY = 0
            DCF77_PARITY_ERROR_HOUR
            DCF77_PARITY_ERROR_MINUTE
            DCF77_PARITY_ERROR_DATE
            DCF77_CYCLE_ERROR
            DCF77_PULSE_RANGE_ERROR
            DCF77_NO_STATUS
        End Enum
        Enum eDCF77StatusCodes
            DCF77_INIT = 0
            DCF77_SYNCING
            DCF77_WAIT_FOR_SYNCING
        End Enum
        Private Function fGetCurrentStatusText(ByVal iCurrentstate As Integer) As String
            Select Case iCurrentstate
                Case eDCF77StatusCodes.DCF77_INIT
                    Return (oTranslatedStrings.DCF77_INIT)
                Case eDCF77StatusCodes.DCF77_SYNCING
                    Return (oTranslatedStrings.DCF77_SYNCING)
                Case eDCF77StatusCodes.DCF77_WAIT_FOR_SYNCING
                    Return (oTranslatedStrings.DCF77_WAIT_FOR_SYNCING)
                Case Else
                    Return (oTranslatedStrings.UNKNOWN_STATE)
            End Select
        End Function
        Private Function fGetLastResultText(ByVal iLastResult As Integer) As String
            Select Case iLastResult
                Case eDCFLastResult.DCF77_RECEIVE_COMPLETE_SUCCESSFULLY
                    Return (oTranslatedStrings.ok)
                Case eDCFLastResult.DCF77_PULSE_RANGE_ERROR
                    Return (oTranslatedStrings.DCF77_PULSE_RANGE_ERROR)
                Case eDCFLastResult.DCF77_NO_STATUS
                    Return (oTranslatedStrings.DCF77_NO_STATUS)
                Case eDCFLastResult.DCF77_CYCLE_ERROR
                    Return (oTranslatedStrings.DCF77_CYCLE_ERROR)
                Case eDCFLastResult.DCF77_PARITY_ERROR_HOUR
                    Return (oTranslatedStrings.DCF77_PARITY_ERROR_HOUR)
                Case eDCFLastResult.DCF77_PARITY_ERROR_MINUTE
                    Return (oTranslatedStrings.DCF77_PARITY_ERROR_MINUTE)
                Case eDCFLastResult.DCF77_PARITY_ERROR_DATE
                    Return (oTranslatedStrings.DCF77_PARITY_ERROR_DATE)
                Case Else
                    Return (oTranslatedStrings.UNKNOWN_STATE)
            End Select
        End Function
        Public ReadOnly Property currentstatestring() As String
            Get
                Return (sCurrentStateText)
            End Get
        End Property
        Public ReadOnly Property lastresultstring() As String
            Get
                Return (sLastResultText)
            End Get
        End Property
        Public ReadOnly Property datetimestring() As String
            Get
                Return (sDCF77Date)
            End Get
        End Property
        Public ReadOnly Property datetime() As DateTime
            Get
                Return (oDCF77DateTime)
            End Get
        End Property
        Public Property weekday() As DayOfWeek
            Get
                Return (iWeekday)
            End Get
            Set(ByVal value As DayOfWeek)
                iWeekday = value
            End Set
        End Property
        Public Property year() As Integer
            Get
                Return (iYear)
            End Get
            Set(ByVal value As Integer)
                iYear = value
            End Set
        End Property
        Public Property month() As Integer
            Get
                Return (iMonth)
            End Get
            Set(ByVal value As Integer)
                iMonth = value
            End Set
        End Property
        Public Property day() As Integer
            Get
                Return (iDay)
            End Get
            Set(ByVal value As Integer)
                iDay = value
            End Set
        End Property
        Public Property hour() As Integer
            Get
                Return (iHour)
            End Get
            Set(ByVal value As Integer)
                iHour = value
            End Set
        End Property
        Public Property minute() As Integer
            Get
                Return (iMinute)
            End Get
            Set(ByVal value As Integer)
                iMinute = value
            End Set
        End Property
        Public Property second() As Integer
            Get
                Return (iSecond)
            End Get
            Set(ByVal value As Integer)
                iSecond = value
            End Set
        End Property
        Public Property valid4seconds() As Integer
            Get
                Return (iValid4Seconds)
            End Get
            Set(ByVal value As Integer)
                iValid4Seconds = value
            End Set
        End Property
        Public Property laststatus() As Integer
            Get
                Return (iLastStatus)
            End Get
            Set(ByVal value As Integer)
                iLastStatus = value
            End Set
        End Property
        Public Property currentstatus() As Integer
            Get
                Return (iCurrentStatus)
            End Get
            Set(ByVal value As Integer)
                iCurrentStatus = value
            End Set
        End Property
        Public Property lastreceivedinseconds() As Integer
            Get
                Return (iLastReceivedInSeconds)
            End Get
            Set(ByVal value As Integer)
                iLastReceivedInSeconds = value
            End Set
        End Property
        Private Function fGetMEZString(ByVal bMEZ As Boolean) As String
            If bMEZ Then
                Return ("MEZ")
            Else
                Return ("MESZ")
            End If
        End Function
        Private Function fGetIntAS2DigitString(ByVal iIn As Integer) As String
            If iIn <= 9 And iIn >= 0 Then
                Return ("0" & iIn.ToString)
            Else
                Return (iIn.ToString)
            End If
        End Function
        Private Function fGetWeekdayString(ByVal iWeekday As Integer)
            Select Case iWeekday
                Case System.DayOfWeek.Sunday
                    Return (oTranslatedStrings.Sunday)
                Case System.DayOfWeek.Monday
                    Return (oTranslatedStrings.Monday)
                Case System.DayOfWeek.Tuesday
                    Return (oTranslatedStrings.Tuesday)
                Case System.DayOfWeek.Wednesday
                    Return (oTranslatedStrings.Wednesday)
                Case System.DayOfWeek.Thursday
                    Return (oTranslatedStrings.Thursday)
                Case System.DayOfWeek.Friday
                    Return (oTranslatedStrings.Friday)
                Case System.DayOfWeek.Saturday
                    Return (oTranslatedStrings.Saturday)
                Case Else
                    Return ("---")
            End Select
        End Function
        Public Property inall() As String()
            Get
                Return (aInDataArray)
            End Get
            Set(ByVal value As String())
                aInDataArray = value
                iYear = Convert.ToInt32(aInDataArray.GetValue(0))
                iMonth = Convert.ToInt32(aInDataArray.GetValue(1))
                iDay = Convert.ToInt32(aInDataArray.GetValue(2))
                iWeekday = Convert.ToInt32(aInDataArray.GetValue(3))
                iHour = Convert.ToInt32(aInDataArray.GetValue(4))
                iMinute = Convert.ToInt32(aInDataArray.GetValue(5))
                iSecond = Convert.ToInt32(aInDataArray.GetValue(6))
                If aInDataArray.GetValue(7) = "1" Then
                    bMEZ = True
                Else
                    bMEZ = False
                End If
                iValid4Seconds = Convert.ToInt32(aInDataArray.GetValue(8))
                iLastStatus = Convert.ToInt32(aInDataArray.GetValue(9))
                iCurrentStatus = Convert.ToInt32(aInDataArray.GetValue(10))
                'iLastReceivedInSeconds = Convert.ToInt32(aInDataArray.GetValue(11))
                If iMonth > 0 And iDay > 0 Then
                    oDCF77DateTime = New DateTime(iYear, iMonth, iDay, iHour, iMinute, iSecond)
                    'sDCF77Date = iWeekday.ToString() & "  " & fGetIntAS2DigitString(iDay) & "." & fGetIntAS2DigitString(iMonth) & "." & "20" & iYear.ToString & " " _
                    ' & fGetIntAS2DigitString(iHour) & ":" & fGetIntAS2DigitString(iMinute) & ":" & fGetIntAS2DigitString(iSecond) & " " & fGetMEZString(bMEZ)
                    sDCF77Date = fGetWeekdayString(iWeekday) & "  " & fGetIntAS2DigitString(iDay) & "." & fGetIntAS2DigitString(iMonth) & "." & "20" & iYear.ToString & " " _
                     & fGetIntAS2DigitString(iHour) & ":" & fGetIntAS2DigitString(iMinute) & ":" & fGetIntAS2DigitString(iSecond) & " " & fGetMEZString(bMEZ)
                Else
                    sDCF77Date = oTranslatedStrings.NoDCF77DataReceived
                End If
                sLastResultText = fGetLastResultText(iLastStatus)
                sCurrentStateText = fGetCurrentStatusText(iCurrentStatus)
            End Set
        End Property
        Sub New(ByRef oTransString As TranslatedString)
            oTranslatedStrings = oTransString
        End Sub
    End Class
End Module
